* Demo program for range-filter function, Ranger()
* If any parameter is sent, demo compares unfiltered Browse() with
*   Ranger()-filtered version; otherwise just the latter
* Demo creates test DBF/NTX about 500K; delete them when thru
* See documentation in Ranger.Doc

set proc to rangfunc
versus=(pcount()=1)
ltr='I'                           && Suggested initial range letter
clear

if file('rangdemo.dbf')
  use rangdemo index rangdemo
else
  @ 0,29 say 'CREATING DEMO DATABASE'
  create rangtemp
  do demorec with 'DUM',1
  do demorec with 'NAME',4
  for i=1 to 9
    do demorec with 'DUMMY'+str(i,1),60
  next
  use
  create rangdemo from rangtemp
  erase rangtemp.dbf
  append from rangdemo.dat sdf
  delete all for dum='*'
  index on upper(name) to rangdemo
endif

DO WHILE .T.
  clear
  @ 0,22 say 'Enter range letter (Esc to quit):' get ltr picture '!'
  read
  if lastkey()=27
    exit
  endif
  @ 0,0
  set deleted on
  if versus
    seek ltr
    set filter to upper(name)=ltr
    @ 0,14 say 'EXAMPLE OF BROWSE WITH STANDARD FILTER (Esc to end)'
    @ 1,10 say '(screen painting not complete until field highlight appears)'
    browse(2,0,24,79)
  endif
  seek ltr
  set filter to ranger(ltr)
    @ 0,14 say ' EXAMPLE OF BROWSE WITH RANGER FILTER (Esc to end) '
  browse(1,0,24,79)
ENDDO

clear
return

PROC DEMOREC
para fld,size
append blank
replace field_name with fld,field_type with 'C',field_len with size
return
