* Range-filter function ideal for browsing
* See documentation in Ranger.Doc

FUNCTION RANGER
parameters topvalue,endvalue,extra,setdel,setsoft
if eof()
  return .F.
elseif type('in_ranger')='L'
  return .T.                       && Recursions handled here
endif

if pcount()<5
  setsoft=.F.
  if pcount()<4
    setdel=.T.
    if pcount()<3
      extra='.T.'
      if pcount()<2
        endvalue=left(topvalue,len(topvalue)-1)+chr(1+asc(right(topvalue,1)))
      endif
    elseif empty(m->extra)
      extra='.T.'
    endif
  endif
endif

private rangeno,xkey
xkey=indexkey(0)
rangeno=inrange()
if rangeno<3                       && Currently within range
  return m->rangeno=1
endif

private in_ranger,ok_ranger
in_ranger=.T.
set deleted off

if m->rangeno=3                    && Currently in before-range
  skip
  rangeno=if(eof(),4,inrange())
  if m->rangeno=3
    set softseek off
    seek topvalue
    rangeno=if(eof(),4,inrange())
    if m->rangeno<>4
      ok_ranger=(m->rangeno=1)
    endif
  else
    goto top
    ok_ranger=.F.
  endif

else                               && Currently in after-range
  skip -1
  rangeno=if(bof(),3,inrange())
  if m->rangeno=4
    set softseek on
    seek endvalue
    skip -1
    rangeno=if(bof(),3,inrange())
    if m->rangeno<>3
      ok_ranger=(m->rangeno=1)
    endif
  else
    goto bottom
    ok_ranger=.F.
  endif
endif

if type('m->ok_ranger')<>'L'
  goto 0
  ok_ranger=.F.
endif

set softseek (m->setsoft)
set deleted (m->setdel)
return m->ok_ranger

FUNCTION INRANGE
private x
x=&xkey
if m->x<m->topvalue                && In before-range = 3
  return 3
elseif m->x>=m->endvalue           && In after-range = 4
  return 4
elseif deleted().and.m->setdel     && In range but excluded = 2
  return 2
elseif &extra                      && In range and included = 1
  return 1
else                               && In range but excluded = 2
  return 2
endif
